<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelMTC {
    
    protected $relMTC;
    protected $util;

    public function __construct (Utilities\Util $util,  Services\RelMTCService $relMTC){
        $this->utilService = $util;
        $this->reportService = $relMTC;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        ini_set('max_execution_time', 1800);
		ini_set('memory_limit', '512M');
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        
        $return = $this->reportService->getBase($conditions);
        
        $allData = [];
        foreach ($return as $dados){
            $prod = array_column($dados, null, 'CDPRODUTO');
            $diff = array_diff_key($prod, $allData);
            $intersect = array_intersect_key($prod, $allData);
            
            if (!empty($diff)){
                foreach ($diff as $chave => $value) {
                    $allData[$chave] = $value;
                }
            }
            
            if(!empty($intersect)){
                foreach ($intersect as $chave => $value) {
                    $keys = array_keys($value);
                    $labelIndex = array_pop($keys);
                    
                     $allData[$chave][$labelIndex] = $value[$labelIndex];
                }
            }
        }
        
        $allData = array_values($allData);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('orm00012_relMTC', $allData));
    }
    
    
}