<?php

namespace Teknisa\MAN\Services;

class CampanhaCompreGanheProdutoService {
	
	public $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	

	public function getIntervaloProdutos($CDCAMPCOMPGANHE, $DTINIVGCAMPCG, $NRORG, $CDPRODUTOINI, $CDPRODUTOFIN ){
		$params = array(
			':CDCAMPCOMPGANHE'  => $CDCAMPCOMPGANHE,
			':DTINIVGCAMPCG'    => $DTINIVGCAMPCG,
			':NRORG'            => $NRORG,
			':CDPRODUTOINI' 	=> $CDPRODUTOINI,
			':CDPRODUTOFIN' 	=> $CDPRODUTOFIN
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::GET_INTERVALO_PRODUTOS_TO_SAVE, $params);
	}	

	public function saveCampanhaProduto($CDCAMPCOMPGANHE, $DTINIVGCAMPCG, $CDPRODUTO, $NRORG){
		$params = array(
			':CDCAMPCOMPGANHE'  => $CDCAMPCOMPGANHE,
			':DTINIVGCAMPCG'    => $DTINIVGCAMPCG,
			':CDPRODUTO'        => $CDPRODUTO,
			':NRORG'            => $NRORG 
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_CAMPANHA_FILIAL, $params);
	}
	
	public function getIntervaloBrindes($CDCAMPCOMPGANHE, $DTINIVGCAMPCG, $NRORG, $CDPRODUTOINI, $CDPRODUTOFIN ){
		$params = array(
			':CDCAMPCOMPGANHE'  => $CDCAMPCOMPGANHE,
			':DTINIVGCAMPCG'    => $DTINIVGCAMPCG,
			':NRORG'            => $NRORG,
			':CDPRODUTOINI' 	=> $CDPRODUTOINI,
			':CDPRODUTOFIN' 	=> $CDPRODUTOFIN
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::GET_INTERVALO_PRODUTOS_BRINDE_TO_SAVE, $params);
	}	

	public function saveCampanhaBrinde($CDCAMPCOMPGANHE, $DTINIVGCAMPCG, $CDPRODUTO, $NRORG){
		$params = array(
			':CDCAMPCOMPGANHE'  => $CDCAMPCOMPGANHE,
			':DTINIVGCAMPCG'    => $DTINIVGCAMPCG,
			':CDPRODUTO'        => $CDPRODUTO,
			':NRORG'            => $NRORG 
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::INSERT_CAMPANHA_BRINDE_FILIAL, $params);
	}
	
	const INSERT_CAMPANHA_FILIAL = "
        INSERT INTO PRCAMPCOMPGANHE (CDCAMPCOMPGANHE, DTINIVGCAMPCG, CDPRODUTO, NRORG) 
             VALUES (:CDCAMPCOMPGANHE, :DTINIVGCAMPCG, :CDPRODUTO, :NRORG)
    ";
    
    const GET_INTERVALO_PRODUTOS_TO_SAVE = "
    	SELECT DISTINCT IT.CDPRODUTO 
    	  FROM ITEMPRECO IT
    	  JOIN PRODUTO PR
    	  ON IT.CDPRODUTO = PR.CDPRODUTO
    	 WHERE PR.NRORG = :NRORG 
    	   AND (NVL(PR.IDPRODATIVPR,'S') = 'S')
    	   AND (PR.CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN)
    	   AND IT.CDPRODUTO NOT IN (
    			SELECT PC.CDPRODUTO 
    			  FROM PRCAMPCOMPGANHE PC
    			 WHERE (PC.CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN)
    			   AND PC.CDCAMPCOMPGANHE = :CDCAMPCOMPGANHE
    			   AND PC.DTINIVGCAMPCG   = :DTINIVGCAMPCG
    		)
    ";
	
	const INSERT_CAMPANHA_BRINDE_FILIAL = "
        INSERT INTO BRCAMPCOMPGANHE (CDCAMPCOMPGANHE, DTINIVGCAMPCG, CDPRODUTO, NRORG) 
             VALUES (:CDCAMPCOMPGANHE, :DTINIVGCAMPCG, :CDPRODUTO, :NRORG)
    ";
    
    const GET_INTERVALO_PRODUTOS_BRINDE_TO_SAVE = "
    	SELECT DISTINCT IT.CDPRODUTO 
    	  FROM ITEMPRECO IT
    	  JOIN PRODUTO PR
    	  ON IT.CDPRODUTO = PR.CDPRODUTO
    	 WHERE PR.NRORG = :NRORG 
    	   AND (NVL(PR.IDPRODATIVPR,'S') = 'S')
    	   AND (PR.CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN)
    	   AND IT.CDPRODUTO NOT IN (
    			SELECT PC.CDPRODUTO 
    			  FROM BRCAMPCOMPGANHE PC
    			 WHERE (PC.CDPRODUTO BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN)
    			   AND PC.CDCAMPCOMPGANHE = :CDCAMPCOMPGANHE
    			   AND PC.DTINIVGCAMPCG   = :DTINIVGCAMPCG
    		)
    ";
}